prereq.sh 18 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678
  1. #!/bin/sh
  2. # This file is part of the OpenADK project. OpenADK is copyrighted
  3. # material, please see the LICENCE file in the top-level directory.
  4. # resolve prerequisites for OpenADK build
  5. topdir=$(pwd)
  6. target="$@"
  7. flags="$MAKEFLAGS"
  8. out=0
  9. mirror=http://distfiles.openadk.org
  10. makever=4.1
  11. bashver=4.3.30
  12. # detect operating system
  13. os=$(env uname)
  14. osver=$(env uname -r)
  15. printf " ---> $os $osver for build detected.\n"
  16. # check if the filesystem is case sensitive
  17. rm -f foo
  18. echo >FOO
  19. if [ -e foo ]; then
  20. printf "ERROR: OpenADK cannot be built in a case-insensitive file system."
  21. case $os in
  22. CYG*)
  23. printf "Building OpenADK on $os needs a small registry change."
  24. printf "http://cygwin.com/cygwin-ug-net/using-specialnames.html"
  25. ;;
  26. Darwin*)
  27. printf "Building OpenADK on $os needs a case-sensitive disk partition."
  28. printf "For Snow Leopard and above you can use diskutil to resize your existing disk."
  29. printf "Example: sudo diskutil resizeVolume disk0s2 90G 1 jhfsx adk 30G"
  30. printf "For older versions you might consider to use a disk image:"
  31. printf "hdiutil create -type SPARSE -fs 'Case-sensitive Journaled HFS+' -size 30g ~/openadk.dmg"
  32. ;;
  33. esac
  34. rm -f FOO
  35. exit 1
  36. fi
  37. rm -f FOO
  38. # do we have a download tool?
  39. tools="curl wget"
  40. for tool in $tools; do
  41. printf " ---> checking if $tool is installed.. "
  42. if which $tool >/dev/null; then
  43. printf "found\n"
  44. case $tool in
  45. curl)
  46. FETCHCMD="$(which $tool) -L -k -f -s -o "
  47. ;;
  48. wget)
  49. FETCHCMD="$(which $tool) --no-check-certificate -q -O "
  50. ;;
  51. esac
  52. break
  53. else
  54. printf "not found\n"
  55. continue
  56. fi
  57. done
  58. if [ -z "$FETCHCMD" ]; then
  59. printf "ERROR: no download tool found. Fatal error.\n"
  60. exit 1
  61. fi
  62. # do we have a checksum tool?
  63. tools="sha256sum sha256 cksum shasum"
  64. for tool in $tools; do
  65. printf " ---> checking if $tool is installed.. "
  66. if which $tool >/dev/null 2>/dev/null; then
  67. printf "found\n"
  68. # check if cksum is usable
  69. case $tool in
  70. sha256sum)
  71. SHA256=$(which $tool)
  72. ;;
  73. sha256)
  74. SHA256="$(which $tool) -q"
  75. ;;
  76. cksum)
  77. if cksum -q >/dev/null 2>/dev/null; then
  78. SHA256="$(which $tool) -q -a sha256"
  79. else
  80. continue
  81. fi
  82. ;;
  83. shasum)
  84. SHA256="$(which $tool) -a 256"
  85. ;;
  86. esac
  87. break
  88. else
  89. printf "not found\n"
  90. continue
  91. fi
  92. done
  93. if [ -z "$SHA256" ]; then
  94. printf "ERROR: no checksum tool found. Fatal error.\n"
  95. exit 1
  96. fi
  97. # create download dir
  98. if [ ! -d $topdir/dl ]; then
  99. mkdir -p $topdir/dl
  100. fi
  101. # check for c compiler
  102. compilerbins="clang cc gcc"
  103. for compilerbin in $compilerbins; do
  104. printf " ---> checking if $compilerbin is installed.. "
  105. if which $compilerbin >/dev/null; then
  106. printf "found\n"
  107. CC=$compilerbin
  108. break
  109. else
  110. printf "not found\n"
  111. continue
  112. fi
  113. done
  114. # check for c++ compiler
  115. compilerbins="clang++ c++ g++"
  116. for compilerbin in $compilerbins; do
  117. printf " ---> checking if $compilerbin is installed.. "
  118. if which $compilerbin >/dev/null; then
  119. printf "found\n"
  120. CXX=$compilerbin
  121. break
  122. else
  123. printf "not found\n"
  124. continue
  125. fi
  126. done
  127. gnu_host_name=$(${CC} -dumpmachine)
  128. # relocation of topdir?
  129. olddir=$(grep "^ADK_TOPDIR" prereq.mk 2>/dev/null |cut -d '=' -f 2)
  130. newdir=$(pwd)
  131. if [ ! -z "$olddir" ]; then
  132. if [ "$olddir" != "$newdir" ]; then
  133. printf " ---> adk directory was relocated, fixing .."
  134. sed -i -e "s#$olddir#$newdir#g" $(find target_* -name \*.pc|xargs) 2>/dev/null
  135. sed -i -e "s#$olddir#$newdir#g" $(find host_${gnu_host_name} -type f|xargs) 2>/dev/null
  136. sed -i -e "s#$olddir#$newdir#g" $(find target_*/scripts -type f|xargs) 2>/dev/null
  137. sed -i -e "s#$olddir#$newdir#" target_*/etc/ipkg.conf 2>/dev/null
  138. sleep 2
  139. printf "done\n"
  140. fi
  141. fi
  142. case :$PATH: in
  143. (*:$topdir/host_${gnu_host_name}/bin:*) ;;
  144. (*) export PATH=$topdir/host_${gnu_host_name}/bin:$PATH ;;
  145. esac
  146. # check for GNU make
  147. makebins="gmake make"
  148. for makebin in $makebins; do
  149. printf " ---> checking if $makebin is installed.. "
  150. if which $makebin >/dev/null 2>/dev/null; then
  151. printf "found\n"
  152. printf " ---> checking if it is GNU make.. "
  153. $makebin --version 2>/dev/null| grep GNU >/dev/null
  154. if [ $? -eq 0 ]; then
  155. printf "yes\n"
  156. MAKE=$(which $makebin)
  157. break
  158. else
  159. # we need to build GNU make
  160. printf "no\n"
  161. printf " ---> compiling missing GNU make.. "
  162. cd dl
  163. $FETCHCMD make-${makever}.tar.gz $mirror/make-${makever}.tar.gz
  164. if [ $? -ne 0 ]; then
  165. printf "ERROR: failed to download make from $mirror\n"
  166. exit 1
  167. fi
  168. cd ..
  169. mkdir tmp
  170. cd tmp
  171. tar xzf ../dl/make-${makever}.tar.gz
  172. cd make-$makever
  173. ./configure --prefix=$topdir/host_$gnu_host_name/
  174. make
  175. make install
  176. cd ..
  177. cd ..
  178. rm -rf tmp
  179. MAKE=$topdir/host_$gnu_host_name/bin/make
  180. makebin=$topdir/host_$gnu_host_name/bin/make
  181. printf " done\n"
  182. fi
  183. else
  184. printf "not found\n"
  185. continue
  186. fi
  187. done
  188. # check for bash
  189. printf " ---> checking if bash is installed.. "
  190. if which bash >/dev/null; then
  191. printf "found\n"
  192. printf " ---> checking if it is bash 4.x.. "
  193. bash --version 2>/dev/null| grep -i "Version 4" >/dev/null
  194. if [ $? -eq 0 ]; then
  195. printf "yes\n"
  196. else
  197. # we need to build GNU bash 4.x
  198. printf "not found\n"
  199. printf " ---> compiling missing GNU bash.. "
  200. cd dl
  201. $FETCHCMD bash-${bashver}.tar.gz $mirror/bash-${bashver}.tar.gz
  202. if [ $? -ne 0 ]; then
  203. printf "ERROR: failed to download make from $mirror\n"
  204. exit 1
  205. fi
  206. cd ..
  207. mkdir tmp
  208. cd tmp
  209. tar xzf ../dl/bash-${bashver}.tar.gz
  210. cd bash-${bashver}
  211. ./configure --prefix=$topdir/host_$gnu_host_name/
  212. make
  213. make install
  214. cd ..
  215. cd ..
  216. rm -rf tmp
  217. printf " done\n"
  218. fi
  219. fi
  220. # skip the script if distclean / cleandir
  221. if [ "$target" = "distclean" -o "$target" = "cleandir" ]; then
  222. touch prereq.mk
  223. $makebin ADK_TOPDIR=$topdir -s -f Makefile.adk $flags $target
  224. exit 0
  225. fi
  226. printf " ---> checking if strings is installed.. "
  227. if ! which strings >/dev/null 2>&1; then
  228. echo You must install strings to continue.
  229. echo
  230. out=1
  231. printf "not found\n"
  232. fi
  233. printf "found\n"
  234. printf " ---> checking if perl is installed.. "
  235. if ! which perl >/dev/null 2>&1; then
  236. echo You must install perl to continue.
  237. echo
  238. out=1
  239. printf "not found\n"
  240. fi
  241. printf "found\n"
  242. # creating prereq.mk
  243. echo "ADK_TOPDIR:=$(readlink -nf . 2>/dev/null || pwd -P)" > $topdir/prereq.mk
  244. echo "BASH:=$(which bash)" >> $topdir/prereq.mk
  245. echo "SHELL:=$(which bash)" >> $topdir/prereq.mk
  246. echo "GMAKE:=$MAKE" >> $topdir/prereq.mk
  247. echo "MAKE:=$MAKE" >> $topdir/prereq.mk
  248. echo "FETCHCMD:=$FETCHCMD" >> $topdir/prereq.mk
  249. echo "SHA256:=$SHA256" >> $topdir/prereq.mk
  250. echo "GNU_HOST_NAME:=${gnu_host_name}" >> $topdir/prereq.mk
  251. echo "OS_FOR_BUILD:=${os}" >> $topdir/prereq.mk
  252. echo "ARCH_FOR_BUILD:=$(${CC} -dumpmachine | sed \
  253. -e 's/x86_64-linux-gnux32/x32/' \
  254. -e s'/-.*//' \
  255. -e 's/sparc.*/sparc/' \
  256. -e 's/armeb.*/armeb/g' \
  257. -e 's/arm.*/arm/g' \
  258. -e 's/m68k.*/m68k/' \
  259. -e 's/sh[234]/sh/' \
  260. -e 's/mips-.*/mips/' \
  261. -e 's/mipsel-.*/mipsel/' \
  262. -e 's/i[3-9]86/x86/' \
  263. )" >>prereq.mk
  264. if [ "$CC" = "clang" ]; then
  265. echo "HOST_CC:=${CC} -fbracket-depth=1024" >> $topdir/prereq.mk
  266. else
  267. echo "HOST_CC:=${CC}" >> $topdir/prereq.mk
  268. fi
  269. if [ "$CXX" = "clang++" ]; then
  270. echo "HOST_CXX:=${CXX} -fbracket-depth=1024" >> $topdir/prereq.mk
  271. else
  272. echo "HOST_CXX:=${CXX}" >> $topdir/prereq.mk
  273. fi
  274. echo 'LANGUAGE:=C' >> $topdir/prereq.mk
  275. echo 'LC_ALL:=C' >> $topdir/prereq.mk
  276. echo "_PATH:=$PATH" >> $topdir/prereq.mk
  277. echo "PATH:=${topdir}/scripts:/usr/sbin:$PATH" >> $topdir/prereq.mk
  278. echo "GIT:=$(which git 2>/dev/null)" >> $topdir/prereq.mk
  279. echo "export ADK_TOPDIR GIT SHA256 BASH SHELL" >> $topdir/prereq.mk
  280. # check if compiler works
  281. cat >Makefile.tmp <<'EOF'
  282. include ${ADK_TOPDIR}/prereq.mk
  283. all: test
  284. test: test.c
  285. @${HOST_CC} ${HOST_CFLAGS} -o $@ $^ ${LDADD}
  286. EOF
  287. cat >test.c <<-'EOF'
  288. #include <stdio.h>
  289. int
  290. main()
  291. {
  292. printf("YES");
  293. return (0);
  294. }
  295. EOF
  296. $MAKE --no-print-directory ADK_TOPDIR=$topdir -f Makefile.tmp 2>&1
  297. X=$(./test)
  298. if [ $X != YES ]; then
  299. echo "$X" | sed 's/^/| /'
  300. echo Cannot compile a simple test programme.
  301. echo You must install a host make and C compiler.
  302. echo
  303. out=1
  304. fi
  305. rm test.c test Makefile.tmp 2>/dev/null
  306. # error out on any required prerequisite
  307. if [ $out -ne 0 ]; then
  308. exit $out
  309. fi
  310. host_build_bc=0
  311. if which bc >/dev/null 2>&1; then
  312. if ! echo quit|bc -q 2>/dev/null >/dev/null; then
  313. host_build_bc=1
  314. else
  315. if bc -v 2>&1| grep -q BSD >/dev/null 2>&1; then
  316. host_build_bc=1
  317. fi
  318. fi
  319. else
  320. host_build_bc=1
  321. fi
  322. host_build_bison=0
  323. if ! which bison >/dev/null 2>&1; then
  324. host_build_bison=1
  325. fi
  326. host_build_bzip2=0
  327. if ! which bzip2 >/dev/null 2>&1; then
  328. host_build_bzip2=1
  329. fi
  330. host_build_file=0
  331. if ! which file >/dev/null 2>&1; then
  332. host_build_file=1
  333. fi
  334. host_build_flex=0
  335. if ! which flex >/dev/null 2>&1; then
  336. host_build_flex=1
  337. fi
  338. host_build_m4=0
  339. if ! which m4 >/dev/null 2>&1; then
  340. host_build_m4=1
  341. fi
  342. host_build_mksh=0
  343. if ! which mksh >/dev/null 2>&1; then
  344. host_build_mksh=1
  345. fi
  346. host_build_patch=0
  347. if ! which patch >/dev/null 2>&1; then
  348. host_build_patch=1
  349. fi
  350. host_build_pkgconf=0
  351. if ! which pkgconf >/dev/null 2>&1; then
  352. host_build_pkgconf=1
  353. fi
  354. host_build_tar=0
  355. if which tar >/dev/null 2>&1; then
  356. if ! tar --version 2>/dev/null|grep GNU >/dev/null;then
  357. host_build_tar=1
  358. fi
  359. else
  360. host_build_tar=1
  361. fi
  362. host_build_findutils=0
  363. if which xargs >/dev/null 2>&1; then
  364. if ! xargs --version 2>/dev/null|grep GNU >/dev/null;then
  365. host_build_findutils=1
  366. fi
  367. fi
  368. if which find >/dev/null 2>&1; then
  369. if ! find --version 2>/dev/null|grep GNU >/dev/null;then
  370. host_build_findutils=1
  371. fi
  372. fi
  373. host_build_grep=0
  374. if which grep >/dev/null 2>&1; then
  375. if ! grep --version 2>/dev/null|grep GNU >/dev/null;then
  376. host_build_grep=1
  377. fi
  378. fi
  379. host_build_gawk=0
  380. if ! which gawk >/dev/null 2>&1; then
  381. host_build_gawk=1
  382. fi
  383. host_build_sed=0
  384. if which sed >/dev/null 2>&1; then
  385. if ! sed --version 2>/dev/null|grep GNU >/dev/null;then
  386. host_build_sed=1
  387. fi
  388. fi
  389. host_build_xz=0
  390. if ! which xz >/dev/null 2>&1; then
  391. host_build_xz=1
  392. fi
  393. # optional
  394. host_build_cdrtools=0
  395. if ! which mkisofs >/dev/null 2>&1; then
  396. host_build_cdrtools=1
  397. fi
  398. host_build_ccache=0
  399. if ! which ccache >/dev/null 2>&1; then
  400. host_build_ccache=1
  401. fi
  402. host_build_genext2fs=0
  403. if ! which genext2fs >/dev/null 2>&1; then
  404. host_build_genext2fs=1
  405. fi
  406. host_build_lzma=0
  407. if ! which lzma >/dev/null 2>&1; then
  408. host_build_lzma=1
  409. fi
  410. host_build_lz4=0
  411. if ! which lz4c >/dev/null 2>&1; then
  412. host_build_lz4=1
  413. fi
  414. host_build_lzop=0
  415. if ! which lzop >/dev/null 2>&1; then
  416. host_build_lzop=1
  417. fi
  418. host_build_qemu=0
  419. if ! which qemu-img >/dev/null 2>&1; then
  420. host_build_qemu=1
  421. fi
  422. host_build_coreutils=0
  423. if which tr >/dev/null 2>&1; then
  424. if ! tr --version 2>/dev/null|grep GNU >/dev/null;then
  425. host_build_coreutils=1
  426. fi
  427. fi
  428. echo "config ADK_HOST_BUILD_TOOLS" > $topdir/target/config/Config.in.prereq
  429. printf "\t%s\n" "bool" >> $topdir/target/config/Config.in.prereq
  430. printf "\t%s\n" "default y" >> $topdir/target/config/Config.in.prereq
  431. # always required
  432. if [ $host_build_bc -eq 1 ]; then
  433. printf "\t%s\n" "select ADK_HOST_BUILD_BC" >> $topdir/target/config/Config.in.prereq
  434. fi
  435. if [ $host_build_bison -eq 1 ]; then
  436. printf "\t%s\n" "select ADK_HOST_BUILD_BISON" >> $topdir/target/config/Config.in.prereq
  437. fi
  438. if [ $host_build_bzip2 -eq 1 ]; then
  439. printf "\t%s\n" "select ADK_HOST_BUILD_BZIP2" >> $topdir/target/config/Config.in.prereq
  440. fi
  441. if [ $host_build_file -eq 1 ]; then
  442. printf "\t%s\n" "select ADK_HOST_BUILD_FILE" >> $topdir/target/config/Config.in.prereq
  443. fi
  444. if [ $host_build_flex -eq 1 ]; then
  445. printf "\t%s\n" "select ADK_HOST_BUILD_FLEX" >> $topdir/target/config/Config.in.prereq
  446. fi
  447. if [ $host_build_gawk -eq 1 ]; then
  448. printf "\t%s\n" "select ADK_HOST_BUILD_GAWK" >> $topdir/target/config/Config.in.prereq
  449. fi
  450. if [ $host_build_grep -eq 1 ]; then
  451. printf "\t%s\n" "select ADK_HOST_BUILD_GREP" >> $topdir/target/config/Config.in.prereq
  452. fi
  453. if [ $host_build_m4 -eq 1 ]; then
  454. printf "\t%s\n" "select ADK_HOST_BUILD_M4" >> $topdir/target/config/Config.in.prereq
  455. fi
  456. if [ $host_build_mksh -eq 1 ]; then
  457. printf "\t%s\n" "select ADK_HOST_BUILD_MKSH" >> $topdir/target/config/Config.in.prereq
  458. fi
  459. if [ $host_build_patch -eq 1 ]; then
  460. printf "\t%s\n" "select ADK_HOST_BUILD_PATCH" >> $topdir/target/config/Config.in.prereq
  461. fi
  462. if [ $host_build_pkgconf -eq 1 ]; then
  463. printf "\t%s\n" "select ADK_HOST_BUILD_PKGCONF" >> $topdir/target/config/Config.in.prereq
  464. fi
  465. if [ $host_build_findutils -eq 1 ]; then
  466. printf "\t%s\n" "select ADK_HOST_BUILD_FINDUTILS" >> $topdir/target/config/Config.in.prereq
  467. fi
  468. if [ $host_build_sed -eq 1 ]; then
  469. printf "\t%s\n" "select ADK_HOST_BUILD_SED" >> $topdir/target/config/Config.in.prereq
  470. fi
  471. if [ $host_build_tar -eq 1 ]; then
  472. printf "\t%s\n" "select ADK_HOST_BUILD_TAR" >> $topdir/target/config/Config.in.prereq
  473. fi
  474. if [ $host_build_xz -eq 1 ]; then
  475. printf "\t%s\n" "select ADK_HOST_BUILD_XZ" >> $topdir/target/config/Config.in.prereq
  476. fi
  477. # optional
  478. if [ $host_build_ccache -eq 1 ]; then
  479. printf "\t%s\n" "select ADK_HOST_BUILD_CCACHE if ADK_HOST_NEED_CCACHE" >> $topdir/target/config/Config.in.prereq
  480. fi
  481. if [ $host_build_cdrtools -eq 1 ]; then
  482. printf "\t%s\n" "select ADK_HOST_BUILD_CDRTOOLS if ADK_HOST_NEED_CDRTOOLS" >> $topdir/target/config/Config.in.prereq
  483. fi
  484. if [ $host_build_genext2fs -eq 1 ]; then
  485. printf "\t%s\n" "select ADK_HOST_BUILD_GENEXT2FS if ADK_HOST_NEED_GENEXT2FS" >> $topdir/target/config/Config.in.prereq
  486. fi
  487. if [ $host_build_lzma -eq 1 ]; then
  488. printf "\t%s\n" "select ADK_HOST_BUILD_LZMA if ADK_HOST_NEED_LZMA" >> $topdir/target/config/Config.in.prereq
  489. fi
  490. if [ $host_build_lz4 -eq 1 ]; then
  491. printf "\t%s\n" "select ADK_HOST_BUILD_LZ4 if ADK_HOST_NEED_LZ4" >> $topdir/target/config/Config.in.prereq
  492. fi
  493. if [ $host_build_lzop -eq 1 ]; then
  494. printf "\t%s\n" "select ADK_HOST_BUILD_LZOP if ADK_HOST_NEED_LZOP" >> $topdir/target/config/Config.in.prereq
  495. fi
  496. if [ $host_build_qemu -eq 1 ]; then
  497. printf "\t%s\n" "select ADK_HOST_BUILD_QEMU if ADK_HOST_NEED_QEMU" >> $topdir/target/config/Config.in.prereq
  498. fi
  499. if [ $host_build_coreutils -eq 1 ]; then
  500. printf "\t%s\n" "select ADK_HOST_BUILD_COREUTILS if ADK_HOST_NEED_COREUTILS" >> $topdir/target/config/Config.in.prereq
  501. fi
  502. # create Host OS symbols
  503. case $os in
  504. Linux)
  505. printf "\nconfig ADK_HOST_LINUX\n" >> $topdir/target/config/Config.in.prereq
  506. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  507. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  508. ;;
  509. Darwin)
  510. printf "\nconfig ADK_HOST_DARWIN\n" >> $topdir/target/config/Config.in.prereq
  511. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  512. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  513. ;;
  514. OpenBSD)
  515. printf "\nconfig ADK_HOST_OPENBSD\n" >> $topdir/target/config/Config.in.prereq
  516. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  517. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  518. ;;
  519. FreeBSD)
  520. printf "\nconfig ADK_HOST_FREEBSD\n" >> $topdir/target/config/Config.in.prereq
  521. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  522. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  523. ;;
  524. NetBSD)
  525. printf "\nconfig ADK_HOST_NETBSD\n" >> $topdir/target/config/Config.in.prereq
  526. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  527. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  528. ;;
  529. MirBSD)
  530. printf "\nconfig ADK_HOST_MIRBSD\n" >> $topdir/target/config/Config.in.prereq
  531. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  532. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  533. ;;
  534. Cygwin*)
  535. printf "\nconfig ADK_HOST_CYGWIN\n" >> $topdir/target/config/Config.in.prereq
  536. printf "\tbool\n" >> $topdir/target/config/Config.in.prereq
  537. printf "\tdefault y\n" >> $topdir/target/config/Config.in.prereq
  538. ;;
  539. esac
  540. if [ "$target" = "defconfig" ]; then
  541. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  542. exit 0
  543. fi
  544. if [ ! -f $topdir/.config ]; then
  545. # create a config if no exist
  546. touch .firstrun
  547. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk menuconfig
  548. else
  549. # scan host-tool prerequisites of certain packages before building.
  550. . $topdir/.config
  551. if [ -n "$ADK_PACKAGE_KODI" ]; then
  552. NEED_JAVA="$NEED_JAVA kodi"
  553. fi
  554. if [ -n "$ADK_PACKAGE_ICU4C" ]; then
  555. NEED_STATIC_LIBSTDCXX="$NEED_STATIC_LIBSTDCXX icu4c"
  556. fi
  557. if [ -n "$ADK_PACKAGE_XKEYBOARD_CONFIG" ]; then
  558. NEED_XKBCOMP="$NEED_XKBCOMP xkeyboard-config"
  559. fi
  560. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_100DPI" ]; then
  561. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-100dpi"
  562. fi
  563. if [ -n "$ADK_PACKAGE_FONT_BITSTREAM_75DPI" ]; then
  564. NEED_MKFONTDIR="$NEED_MKFONTDIR font-bitstream-75dpi"
  565. fi
  566. if [ -n "$ADK_PACKAGE_FONT_ADOBE_100DPI" ]; then
  567. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-100dpi"
  568. fi
  569. if [ -n "$ADK_PACKAGE_FONT_ADOBE_75DPI" ]; then
  570. NEED_MKFONTDIR="$NEED_MKFONTDIR font-adobe-75dpi"
  571. fi
  572. if [ -n "$NEED_MKFONTDIR" ]; then
  573. if ! which mkfontdir >/dev/null 2>&1; then
  574. printf "You need mkfontdir to build $NEED_MKFONTDIR"
  575. out=1
  576. fi
  577. fi
  578. if [ -n "$NEED_XKBCOMP" ]; then
  579. if ! which xkbcomp >/dev/null 2>&1; then
  580. printf "You need xkbcomp to build $NEED_XKBCOMP"
  581. out=1
  582. fi
  583. fi
  584. if [ -n "$NEED_JAVA" ]; then
  585. if ! which java >/dev/null 2>&1; then
  586. printf "You need java to build $NEED_JAVA"
  587. out=1
  588. fi
  589. fi
  590. if [ -n "$NEED_STATIC_LIBSTDCXX" ]; then
  591. cat >test.c <<-'EOF'
  592. #include <stdio.h>
  593. int
  594. main()
  595. {
  596. return (0);
  597. }
  598. EOF
  599. if ! $CXX -static-libstdc++ -o test test.c 2>/dev/null ; then
  600. printf "You need static version of libstdc++ installed to build $NEED_STATIC_LIBSTDCXX"
  601. out=1
  602. rm test test.c 2>/dev/null
  603. fi
  604. fi
  605. # error out
  606. if [ $out -ne 0 ]; then
  607. exit $out
  608. fi
  609. # start build
  610. $makebin ADK_TOPDIR=$topdir --no-print-directory -f Makefile.adk $flags $target
  611. fi